#Version = "V1.01"

Global SerialPortHandle.l, UDPServerHandle.l
Global NetzwerkGestartet.b, Ergebnis.s

Global *GlobalText = AllocateMemory(16384)

XIncludeFile "Serial.pbi"
XIncludeFile "Listview.pbi"
XIncludeFile "MainWindow.pbi"

InitWindow_0() ; ffnet das erste Fenster. Dieser Prozedurname ist immer 'Open' gefolgt vom Fensternamen.

*DatenPuffer = AllocateMemory(21)

; Die bliche Haupt-Ereignisschleife, die einzige nderung ist der automatische Aufruf der
; fr jedes Fenster generierten Ereignis-Prozedur.



Repeat
  Event = WaitWindowEvent(10)
  ;Debug(Event)

  Select EventWindow()
    Case Window_0
      If Not Window_0_Events(Event)
        Event = #PB_Event_CloseWindow
      EndIf
  
  EndSelect
  
  If NetzwerkGestartet
    UDPEvent = NetworkServerEvent()
    Select UDPEvent
      Case #PB_NetworkEvent_Data
        FillMemory(*DatenPuffer, 21)   ;Puffer mit Nullen fllen
        UDPClient = EventClient()
        UDPDaten = ReceiveNetworkData(UDPClient, *DatenPuffer, 20)
        ;PufferText.s = PeekS(*DatenPuffer)   ;nicht gut
        PufferText.s = Unicode(*DatenPuffer, #PB_UTF8)   ;Macro aus Serial.pbi
        TextSchreiben(Editor_5, "Von: " + IPString(GetClientIP(UDPClient)) + " Daten: " + PufferText.s)
        If SerialPortHandle.l
          ;Hier der Translator fr "$" > ","
          PufferText.s = ReplaceString(PufferText.s, "$", ",")
          PufferText.s = Trim(PufferText.s)   ;allen Scheiss entfernen
          PufferText.s = UCase(PufferText.s)   ;und in Grossbuchstaben umwandeln
          WriteSerialPortString(SerialPortHandle.l, PufferText.s + Chr(13), #PB_UTF8)
        EndIf
    EndSelect
  EndIf

Until Event = #PB_Event_CloseWindow

OpenPreferences("ibm.ini")
PreferenceGroup("settings")
;dekoder=U:\Projekte\Intellibox-Manager\MERG.csv
WritePreferenceLong("fensterposition_x", WindowX(Window_0))
WritePreferenceLong("fensterposition_y", WindowY(Window_0))
WritePreferenceLong("loknummer", Val(GetGadgetText(Spin_0)))
WritePreferenceLong("udp-port", Val(GetGadgetText(Spin_5)))
WritePreferenceString("dekoder", ListViewDekoder.s)
ClosePreferences()

If ListViewHandle
  Vernichte_Listview()
EndIf

If ListViewLibraryHandle
  CloseLibrary(ListViewLibraryHandle)
EndIf

If IsSerialPort(SerialPortHandle.l)
  CloseSerialPort(SerialPortHandle.l)
EndIf

FreeMemory(*DatenPuffer)
FreeMemory(*GlobalText)


; IDE Options = PureBasic 5.62 (Windows - x86)
; EnableXP
; UseIcon = gP.ico
; Executable = IBM.exe
; Watchlist = Text;Text;Text;SerialPortHandle